# Renderbug: An embedded art engine

[![Documentation Status](https://readthedocs.org/projects/renderbug/badge/?version=latest)](https://renderbug.readthedocs.io/en/latest/?badge=latest)
[![Build Status](http://woodpecker.cloud.malloc.hackerbots.net:8000/api/badges/tdfischer/renderbug/status.svg)](http://woodpecker.cloud.malloc.hackerbots.net:8000/tdfischer/renderbug)

Renderbug is a fast, efficient, and beautiful LED art engine for the ESP32 and
other chipsets that are able to talk to WS2812b (aka Neopixel) RGB LEDs.

## Features

- Fun to use
- Fast as hell
- Microkernel architecture
- Functional API
- JSON Configuration
- Live reconfiguration
- Connectivity over Serial, Bluetooth, MQTT, and others
- Tasklets for rendering, input, and background services
- Surface mapping and projection algorithms (batteries included)
- Automatic power management
- Sprites
- Native Home Assistant support over MQTT

## Demonstration

[![blazing fast LEDs](https://img.youtube.com/vi/VbPOKY6_bkc/maxresdefault.jpg)](https://www.youtube.com/shorts/VbPOKY6_bkc)
